local versionstring = "r61"
local mountifulcreated = false
local invalidnames = {"hide","remove","add","smart","mounts","safeflying","options","rebuild","debug", "dismiss", "help", "reset", "pet"} -- Don't let people use these as category names
local petsummoned = false
local lastpetsummoned = 0
local Mountiful_Defaults = {}
local Mountiful_Mounts = {}
local rtcf
local mountifulselectednum
local mountifulpagenum

tinsert(UISpecialFrames, "Mountiful") -- Insert the menu frame into UISpecialFrames to it will close when hitting ESC

local MOprintstack = -1
local messagestring = ""
function MOprint(message)
   if(MOdebug) then
		if(MOprintstack == -1) then
			messagestring=""
		end
      local stack, filler
      if not message then
	  	 DEFAULT_CHAT_FRAME:AddMessage(messagestring..tostring(message))
		 return false 
      end
      MOprintstack=MOprintstack+1
      
	  filler=string.rep(". . ",MOprintstack)
      
      if (type(message) == "table") then
	  	-- DEFAULT_CHAT_FRAME:AddMessage("its a table.  length="..MO_tcount(message))
	 	
		DEFAULT_CHAT_FRAME:AddMessage(messagestring.."{table} --> ")
		
	 	for k,v in pairs(message) do
			messagestring = filler.."["..k.."] = "
	    	MOprint(v)
	 	end
      elseif (type(message) == "userdata") then

      elseif (type(message) == "function") then
        DEFAULT_CHAT_FRAME:AddMessage(messagestring.." A Function()")
      elseif (type(message) == "boolean") then
            DEFAULT_CHAT_FRAME:AddMessage(messagestring..tostring(message))
      else
	  	 	DEFAULT_CHAT_FRAME:AddMessage(messagestring..tostring(message))
      end
      MOprintstack=MOprintstack-1
   end
end





-- Checks if value e is in array t
local function in_array(e, t) 
 	for _,v in pairs(t) do
		if (v==e) then return true end
	end
	return false
end

-- Prints msg if debugging is on

function Mountiful_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("COMPANION_LEARNED");

	--Register Slash Commands
	SLASH_MOUNT1 = "/mountiful"
	SLASH_MOUNT2 = "/mount" -- A shortcut or alias
	SlashCmdList["MOUNT"] = function(arg) Mountiful_Command(arg, false); end;

	SLASH_PET1 = "/pet"
	SlashCmdList["PET"] = function(arg) Mountiful_Command(arg, true); end;


	-- Binding Variables
	BINDING_HEADER_MOUNTIFULHDR = "Mountiful Bindings"
	BINDING_NAME_MOUNTIFULBIND1 = "Smart Mounting"
	BINDING_NAME_MOUNTIFULBIND2 = "Pre-Selected Smart Mounting"
	BINDING_NAME_MOUNTIFULBIND3 = "FastGround"
	BINDING_NAME_MOUNTIFULBIND4 = "FastFlying"
	BINDING_NAME_MOUNTIFULBIND5 = "Pet"
	
end

function Mountiful_OnEvent()
	if (event == "VARIABLES_LOADED") then
		Mountiful_Loaded()
	elseif (event == "COMPANION_LEARNED") then -- Rebuild selections array when user learns a new mount/pet
		Mountiful_RebuildSelections()
		Mountiful_CreateMountTables()
	end
end

function Mountiful_Loaded()
	Mountiful_Defaults = {
		["Options"] = {
			revision = 40,
			safeflying = true,
			debugging = false,
		},
		["Categories"] = {
		--[[
			[1] = "Ground",
			[2] = "Flying",
			[3] = "Other",
			[4] = "Other2",
			]]
			[1] = "FastGround",
			[2] = "FastFlying",
			[3] = "SlowGround",
			[4] = "SlowFlying",
			[5] = "ExtremeFlying",
			[6] = "Swimming",
			[7] = "Qiraj",
			[8] = "All",
			[9] = "Pet",
		},
		["Categories_Selections"] = {
			
			["Pet"] = {
				ispet = true,
			},
			
		},
		["Mounts"] = {
			count = 0,
		}
	}
	--start daxdax
	local i, value
	MOprint("Creating default mount table")
	for i,value in ipairs(Mountiful_Defaults.Categories) do
		Mountiful_Defaults.Mounts[value] = {}
	end
	
	Mountiful:EnableMouse()
	Mountiful:SetScript("OnMouseDown", function()  
		Mountiful:StartMoving()
	end)
	Mountiful:SetScript("OnMouseUp", function()  
		Mountiful:StopMovingOrSizing()
	end)
	
	mountifulpagenum = 1
	
	--Mountiful:SetScript("OnShow",Mountiful_Refresh)  --things just isnt happening when its sopposed to.  maybe this will fix it.
		
		
		
		
		
		--patch into the blizzard mount screen
	local tabbutton = CreateFrame("Button","PetPaperDollFrameTab4", PetPaperDollFrameCompanionFrame,"TabButtonTemplate")
	tabbutton:SetID(4)  --needed?  not sure
	tabbutton:SetPoint("left",PetPaperDollFrameTab3,"right")
	--tabbutton:SetWidth(160)
	tabbutton:SetText("Mountiful")
	getglobal(tabbutton:GetName().."HighlightTexture"):SetWidth(tabbutton:GetTextWidth() + 31);
	PanelTemplates_TabResize(tabbutton, 0);
	tabbutton:SetFrameLevel(PetPaperDollFrameCompanionFrame:GetFrameLevel()+1);
	
	tabbutton:SetScript("OnClick", function()
		Mountiful_Command("")
	end)
	
	--Mountiful_CreateMountTables()  --calling this here does NOTHING!  its as if the table was never created!?  is companion info not immediately available?
	--end daxdax
	
	
	if Mountiful_Vars and Mountiful_Vars.version then
		Mountiful_Vars = nil
	end
	if not Mountiful_Vars then
		Mountiful_Vars = Mountiful_Defaults
	end
	if Mountiful_Vars.revision or Mountiful_Vars["Options"]["revision"] < Mountiful_Defaults["Options"]["revision"] then
		MOprint("|C00aa00ffRevision change detected")
		Mountiful_Vars["Options"]["revision"] = Mountiful_Defaults["Options"]["revision"]
		if Mountiful_Vars.revision then
			Mountiful_Vars.revision = nil
			Mountiful_Vars.safeflying = nil
			Mountiful_Vars["Categories_Selections"] = {}
			for k, v in ipairs(Mountiful_Vars.panes) do
				Mountiful_Vars["Categories_Selections"][v] = Mountiful_Vars[v]
				Mountiful_Vars[v] = nil
			end
			MOprint("Replacing var_Categories with vars.panes")
			Mountiful_Vars["Categories"] = Mountiful_Vars.panes
			Mountiful_Vars.panes = nil
		end

		for k, v in pairs(Mountiful_Defaults) do
			if not Mountiful_Vars[k] then
				Mountiful_Vars[k] = Mountiful_Defaults[k]
			end
		end
	end
	
	Mountiful_Options = Mountiful_Vars["Options"]
	--Mountiful_Mounts = Mountiful_Vars["Mounts"]  --why would we want to save mounts between session??  dunno.
	Mountiful_Categories = Mountiful_Vars["Categories"]
	Mountiful_Selections = Mountiful_Vars["Categories_Selections"]
	

	local Categoryfound
		--add all the defaults
	for j = 1,#Mountiful_Defaults.Categories do
		Categoryfound = false
		for i = 1,#Mountiful_Categories do
			if (Mountiful_Categories[i] == Mountiful_Defaults.Categories[j]) then
				Categoryfound = true
				break
			end
		end
		if not Categoryfound then
			Mountiful_Categories[#Mountiful_Categories+1] = Mountiful_Defaults.Categories[j]
		end
	end
	
	Mountiful_CreateMainFrame()
	
	MOprint("|c00ffaaaa END Loaded")
end
function Mountiful_GetCommand(msg)
	if msg then
		local a,b,c=strfind(msg, "(%S+)") --contiguous string of non-space characters
		if a then
			return c, strsub(msg, b+2)
		else	
			return ""
		end
	end
end

function Mountiful_Command(msg, ispet) -- Parse the slash commands
	local rand
	--MOprint("Command recieved:"..msg.."  ispet="..tostring(ispet))

	local msg = SecureCmdOptionParse(msg)
	local Cmd, SubCmd = Mountiful_GetCommand(msg)
	
	--MOprint("Command:"..Cmd.."  Sub:"..tostring(SubCmd))
	
	local tmpcmd, ismountcmd
		for i, panel in pairs(Mountiful_Categories) do -- Check to see if the cmd matches the name of a category
			if (type(panel) == "string") then
				tmp = strlower(panel)
				Cmd = strlower(Cmd)
				if (Cmd == tmp) then
					ismountcmd = true
					tmpcmd = panel
					break
				end
			end
		end
		if (Cmd == "help") then
			print("/mount <Category> - Uses a random mount from that category")
			print("/mount smart - Uses a random mount that suits your location")
			print("/mount smart pre - Uses a random mount from your Flying/Ground lists depending on your location")
			print("/(mount|pet) pet - Uses a random companion")
			print("/(mount|pet) pet pre - Uses a random pre-selected companion")
			print("/(mount|pet) add <Category> - Adds a new category")
			print("/(mount|pet) remove <Category> - Removes a category")
			print("/mount safeflying - Toggles safe flying on|off")
			print("/mount reset - Resets all settings for Mountiful, also causes your ui to reload")
			print("/mount debug - Toggles debug messages on|off")
		elseif (Cmd == "hide") then
			Mountiful:Hide()
		elseif (Cmd == "reset") then
			Mountiful_ResetSettings()
		elseif (Cmd == "add") then
			Mountiful_AddPanel(SubCmd, ispet)
		elseif (Cmd == "remove") then
			Mountiful_RemovePanel(SubCmd)
		elseif (Cmd == "dismiss") then
			DismissCompanion("CRITTER")
			petsummoned = false
		elseif (Cmd == "smart") then
			if SubCmd == "pre" or SubCmd == "predefined" then
				Mountiful_SmartMount(true)
			else
				Mountiful_SmartMount()
			end
		elseif (Cmd == "rebuildselections") then
			print("Rebuilding mount selections database")
			Mountiful_RebuildSelections()
		elseif (Cmd == "debug") then
			MOdebug = not MOdebug
			print(tostring(MOdebug))
		elseif (Cmd == "safeflying") then
			Mountiful_Options.safeflying = not Mountiful_Options.safeflying
			if Mountiful_Options.safeflying then
				print("Safe dismounting on")
			else
				print("Safe dismounting off")
			end
		elseif (ismountcmd) then -- If the command matched the name of a category call the mount function
			if SubCmd == "pre" or SubCmd == "predefined" then
				Mountiful_Mount(tmpcmd,true)
			else
				Mountiful_Mount(tmpcmd)
			end
		else	
			if(Mountiful:IsVisible()) then
				Mountiful:Hide()
			else
				Mountiful:Show()
			end
		end
end
function Mountiful_CreateMainFrame()
	if mountifulcreated then return; end
	mountifulcreated = true
	
	local title = _G["Mountiful_Frame_Title"]
	title:SetText(title:GetText()..versionstring)
	
	Mountiful_CreateMountTables()
	
	
	local parent = getglobal("Mountiful")
	parent:SetScript("OnShow",Mountiful_update)
	local leftpanel = getglobal("Mountiful_LeftPane")
	local leftpanelheight = leftpanel:GetHeight()
	local rightpanel = CreateFrame("Frame", "mountifulrightpanel", parent, "RightPane_Template")
	local paneltext = getglobal(rightpanel:GetName().."_Name")
	local button = CreateFrame("Button", nil, leftpanel, "LeftMenuButton")
	local buttonheight = button:GetHeight()
	rtcf = math.floor(leftpanelheight / buttonheight)  --rows that can fit
	
	for i = 1,rtcf do
		button = CreateFrame("Button", "mountifulleftmenubutton"..i, leftpanel, "LeftMenuButton")
		if(i == 1) then
			button:SetPoint("top",0,-4)
		else
			button:SetPoint("top",getglobal("mountifulleftmenubutton"..i-1),"bottom")
		end

		
	end
	
	local rows = 4
	local columns = 6
	
	for i = 1,rows*columns do
		local mounticon = CreateFrame("Frame", "mountifulicon"..i, rightpanel, "MountifulIcon")
		if (i == 1) then
			firstinrow = mounticon
			mounticon:SetPoint("topleft",16,-26)
		elseif (mod(i, 6) == 1) then
			mounticon:SetPoint("TOPLEFT", firstinrow, "BOTTOMLEFT", 0, 0)
			firstinrow = mounticon
		else
			mounticon:SetPoint("TOPLEFT", previcon, "TOPRIGHT", 0, 0)
		end
		
		previcon = mounticon
	end
	
	getglobal(rightpanel:GetName().."_NextPage"):SetScript("OnClick",Mountiful_NextPage)
	getglobal(rightpanel:GetName().."_PrevPage"):SetScript("OnClick",Mountiful_PrevPage)

	Mountiful_update()
	
end


function Mountiful_update()
--graphical stuff
	MOprint("MOuntiful_update()  mountifulpagenum="..mountifulpagenum)
	Mountiful_updateleftpanel()
	Mountiful_updaterightpanel()

end
function Mountiful_updateleftpanel()
	local buttoni = 1
	for i, category in ipairs(Mountiful_Categories) do
		button = getglobal("mountifulleftmenubutton"..buttoni)
		button.categorynum = i
		button.name = category
		button.index = buttoni
		MOprint("category is currently:"..category)
		if(Mountiful_Mounts[category] and #Mountiful_Mounts[category] > 0) then
			button:Show()
			button:SetText(category.." ("..#Mountiful_Mounts[category]..")")
			buttoni=buttoni+1
		elseif(Mountiful_Mounts[category] and #Mountiful_Mounts[category] <= 0) then
			--dont show 0 count categories?  --skip.  dont increment buttoni
			
		else  -- its a custom category
			button:Show()
			button:SetText(category)
			buttoni=buttoni+1
		end
		
		if(i == mountifulselectednum) then
			button:SetText("|c0000ff55"..button:GetText())  --greeny
		end
		
	end
	button = getglobal("mountifulleftmenubutton"..buttoni)
	while (button) do
		button:Hide()
		buttoni = buttoni + 1
		button = getglobal("mountifulleftmenubutton"..buttoni)
	end
	
end


function Mountiful_updaterightpanel()
	
	local ispet=false
	local rightpanel = getglobal("mountifulrightpanel")
	local paneltext = getglobal(rightpanel:GetName().."_Name")
			
	local endmountnum = mountifulpagenum * 24
	local startmountnum = (mountifulpagenum * 24) - 23
	local mountname, spellID, icon
	local button 
	local mounttexture
	local checkbox
	local iconi=1
	
	if(not mountifulselectednum) then
		mountifulselectednum = 1 --first entry (fastflying, i think)
	end
	
	--MOprint("Mountiful_Categories")
	--MOprint(Mountiful_Categories)
	
	
	panelname = Mountiful_Categories[mountifulselectednum]
	if (not mountifulpagenum) then
		mountifulpagenum = 1
	end
	paneltext:SetText(panelname.." Page "..mountifulpagenum)
	if (Mountiful_Selections[panelname] and Mountiful_Selections[panelname].ispet) then
		ispet = true
		companionType = "CRITTER";
	else
		companionType = "MOUNT";
	end
	local mounts = {}
	if(ispet) then
		mounts = Mountiful_Mounts.Pet
	elseif(Mountiful_Mounts[panelname]) then
		mounts = Mountiful_Mounts[panelname]
	else
		mounts = Mountiful_Mounts.All
	end
	
	if #mounts <= (mountifulpagenum * 24) then -- Disable the next page button if there is only one page
		getglobal(rightpanel:GetName().."_NextPage"):Disable()
	else
		getglobal(rightpanel:GetName().."_NextPage"):Enable()
	end
	if(mountifulpagenum == 1 ) then
		getglobal(rightpanel:GetName().."_PrevPage"):Disable()
	else
		getglobal(rightpanel:GetName().."_PrevPage"):Enable()
	end
	

	for i = startmountnum,endmountnum do
		if (not mounts[i]) then break end;
		 _, mountname, spellID, icon, _ = GetCompanionInfo(companionType, mounts[i])
		if not mountname then break end;
		mounticon = getglobal("mountifulicon"..iconi)
		mounticon:Show()
		button = getglobal(mounticon:GetName().."_MountIcon")
		mounttexture = getglobal(mounticon:GetName().."_MountIcon_IconTexture")
		checkbox = getglobal(mounticon:GetName().."_CheckButton")
		checkbox.mountname = mountname
		
		mounticon.link = GetSpellLink(spellID)
		button.link = GetSpellLink(spellID)
		mounttexture:SetTexture(icon)
		checkbox:SetID(i)
		
		button:SetAttribute("type","spell")  --daxdax
		button:SetAttribute("spell",mountname)
	
		if (Mountiful_Selections[panelname]) then
			if (Mountiful_Selections[panelname][mountname]) then
				checkbox:SetChecked(Mountiful_Selections[panelname][mountname]["checked"])
				Mountiful_Selections[panelname][mountname].id = mounts[i]
			else
				checkbox:SetChecked(false)
				Mountiful_Selections[panelname][mountname] = {}
			end
		else
			checkbox:SetChecked(false)
		end

	
		iconi=iconi+1
	end
	
	--MOprint("Hiding icons +"..iconi)
	mounticon = getglobal("mountifulicon"..iconi)
	while(mounticon) do
		mounticon:Hide()
		iconi=iconi+1
		mounticon = getglobal("mountifulicon"..iconi)
	end
	--MOprint("Hiding end icon "..iconi)
	
	


	
end


function Mountiful_CreatePanel(i, panelname, page) -- Creates the panels
--[[
		local parent = getglobal("Mountiful")
		local leftpane = getglobal("Mountiful_LeftPane")
		if page == 1 then -- If this is the first page
			if(Mountiful_Mounts[panelname]) then  --predefined tables
				if (#Mountiful_Mounts[panelname] <= 0) then --dont show 0 tables
					return nil
				end
			end
		
			panel = CreateFrame("Frame", panelname.."_1", parent, "RightPane_Template")
			local paneltext = getglobal(panel:GetName().."_Name")
			local button = CreateFrame("Button", panelname.."_Button", leftpane, "LeftMenuButton")
			
			getglobal(panelname.."_1".."_PrevPage"):Disable()
			if(Mountiful_Mounts[panelname]) then
				button:SetText(panelname.." ("..#Mountiful_Mounts[panelname]..")")
			else
				button:SetText(panelname)
			end
			paneltext:SetText(panelname)
			if i > 1 then
				local lastbutton = getglobal(Mountiful_Categories[i-1].."_Button")
				button:SetPoint("TOP", lastbutton, "BOTTOM", 0, 0)
				panel:Hide()
			end
		else
			local paneltextname = strsplit("_", panelname)
			paneltextname = paneltextname.." Page "..page
			panel = CreateFrame("Frame", panelname, parent, "RightPane_Template")  
			local paneltext = getglobal(panel:GetName().."_Name")
			paneltext:SetText(paneltextname)
			panel:Hide()
		end
		return panel
		]]
end
local lastpane
function Mountiful_PanelSelect()

	mountifulselectednum = this.categorynum
	mountifulpagenum = 1
	Mountiful_update()
end


function mountifulicon_OnEnter()
	
	--MOprint("ON enter breeched.  link="..this.link)
	GameTooltip:SetOwner(this, "ANCHOR_TOPRIGHT")
	GameTooltip:SetHyperlink(this.link)
	GameTooltip:Show()
	


	--	mounticon:SetScript("OnLeave", function() GameTooltip:Hide() end)
		
		
end


function CheckBox_OnClick() -- Runs when user clicks the checkbox for a mount

	local mountname = this.mountname
	local panelname = Mountiful_Categories[mountifulselectednum]
	
	MOprint("Cleek.  panelname = "..panelname)
	--[[
	local id = this:GetID()
	for i, panel in pairs(Mountiful_Categories) do
		if(type(panel) == "string") then
			if (strfind(this:GetName(), panel)) then
				panelname = panel
			end
		end
	end
	]]
	
	if (not Mountiful_Selections[panelname]) then
		Mountiful_Selections[panelname] = {}
		Mountiful_Selections[panelname][mountname] = {}
	elseif not (Mountiful_Selections[panelname][mountname]) then
		Mountiful_Selections[panelname][mountname] = {}
	end

	if (this:GetChecked()) then -- Mount is now checked, set to checked in Selections and update its id
		MOprint(mountname..": Checked = true; id = "..tostring(id).."; panelname = "..panelname.."; mountname = "..mountname)
		Mountiful_Selections[panelname][mountname]["checked"] = true
		--Mountiful_Selections[panelname][mountname]["id"] = id
	else -- Mount is now unchecked, set to unchecked in Selections and update its id
		
		Mountiful_Selections[panelname][mountname]["checked"] = false
		--Mountiful_Selections[panelname][mountname]["id"] = id
	end
end

function Mountiful_Mount(panel,pre)
	local ispet,rand,summontype,index,value
	local summontable = {}
	
	MOprint("attempting to call mount from "..panel.."    preselected = "..tostring(pre).."  selections_=")
	--MOprint(Mountiful_Selections)
	
	if Mountiful_Selections[panel] and Mountiful_Selections[panel].ispet then
		ispet = true
	end
	
	if(ispet) then
		summontype = "CRITTER"
	else
		summontype = "MOUNT"
	end
	
		
	if (not ispet) and (IsMounted()) then -- If player is already mounted dismount
		if IsFlying() and Mountiful_Options.safeflying then -- If player is flying and safeflying is on don't dismount
		else
			Dismount()
		end
	end

	if (pre) then --pre, meaning, use only the checked mounts/pets in that category
		if(Mountiful_Selections[panel]) then
		--	MOprint("Mountifulselections["..panel.."]  found.  contents:")
		--	MOprint(Mountiful_Selections[panel])
			for mountname, value in pairs(Mountiful_Selections[panel]) do  --panel is the mount category, first entry is the mount name, value is checked/id table
				if(mountname ~= "ispet" and value.checked) then
					if(ispet and value.id == lastpetsummoned) then  --dont call the same pet twice ina row.  i hate that.
						--skip
					else
						summontable[#summontable+1] = value.id
					end
				end
			end
		else
			MOprint("Nothing is pre-selected for panel "..tostring(panel)..".  Defaulting to non pre-selected.")
			MOprint("Mountiful_Selections[panel]")
			MOprint(tostring(Mountiful_Selections[panel]))
			Mountiful_Mount(panel,false)			
			return
		end
		

	else
		if(ispet) then
			summontable = Mountiful_Mounts.Pet
		else
			--if(Mountiful_Defaults.Categories[panel]) then--dammit its not indexed by string grrr
			if(Mountiful_Mounts[panel]) then
				summontable = Mountiful_Mounts[panel]  --there was a premade table made in makealltables()
			else--if(Mountiful_Defaults.Categories[panel]) then--dammit its not indexed by string grrr
				summontable = Mountiful_Mounts.All
				print("No panel found for "..panel.." defaulting to all")
			end
		end
	end
	
	if((#summontable == 0)) then
		--MOprint(summontable)  --almost always an error
		MOprint("table found for "..tostring(panel)..".  but all checked were set to false.  Defaulting to non pre-selected.")
		Mountiful_Mount(panel,false)		
		return
		--do nothing
	elseif(#summontable == 1) then
		rand = 1
	elseif(#summontable > 1) then
		rand = random(1,#summontable)
	end
	CallCompanion(summontype, summontable[rand])
	if(ispet) then
		lastpetsummoned = summontable[rand]
	end
	
end

function Mountiful_AddPanel(newpanel, ispet) -- Add a new category
	local exists = false
	if newpanel == nil or newpanel == "" then
		if ispet == true then
			print("Usage: /pet add <panelname>")
		else
			print("Usage: /mount add <panelname>")
		end
	else
		newpanellower = strlower(newpanel)
		if in_array(newpanellower,invalidnames) then
			print(newpanel.." cannot be used as a Category name")
		else
			for index, value in pairs(Mountiful_Categories) do
				if newpanellower == strlower(value) then
					exists = true
				end
			end
			if exists then
				print("Cannot add panel \""..newpanel.."\", it already exists")
			else
				Mountiful_Categories[#Mountiful_Categories+1] = newpanel
				if (not Mountiful_Selections[newpanel]) then
					Mountiful_Selections[newpanel] = { };
				end
				Mountiful_Selections[newpanel].ispet = ispet
			end
			Mountiful_update()
		end
	end
end
function Mountiful_RemovePanel(panel) -- Remove a category
	if panel == nil then
		print("Usage: /mount remove <panelname>")
		return
	elseif panel == "FastFlying" or panel == "FastGround" then
		print("Cannot remove that panel")
		return
	else
		for index, value in pairs(Mountiful_Categories) do
			if strlower(value) == strlower(panel) then
				Mountiful_Categories[index] = nil
				if (Mountiful_Selections[value]) then
					Mountiful_Selections[value] = nil
				end
				print(value.." was removed")
				Mountiful_update()
				return
			end
		end
	end
	print (panel.." was not removed")
end

function Mountiful_SmartMount(predefined)
	local mountnum = GetNumCompanions("MOUNT")
	local flyable
	local zoneName = GetRealZoneText()
	local subZone = GetSubZoneText()
	local ridingSkill = GetRidingSkill()
	local level = UnitLevel("player") -- Get players level
	local tmpnum
	local coldweatherflying, _ = IsUsableSpell("Cold Weather Flying") -- Does the player have Cold Weather Flying?
	local tablename
	
	--MOprint("zone = "..zoneName.."  subzone = "..subZone)
	
	if IsMounted() then -- If player is already mounted dismount
		if IsFlying() and Mountiful_Options.safeflying then -- If player is flying and safeflying is on don't dismount
		else
			Dismount()
		end
		return
	end

	--Get the continent the player is on
	SetMapToCurrentZone()
	currentContinent = GetCurrentMapContinent()

	--Check if area is flyable and if player is allowed to fly there
	if IsFlyableArea() then
		if currentContinent == 4 and level < 77 then
			flyable = false
		elseif currentContinent == 4 and level >= 77 and not coldweatherflying then
			flyable = false
		else
			if (zoneName == "Wintergrasp" or zoneName == "Dalaran") and not in_array(subZone, Mountiful_flyableSubZones) then
				flyable = false
			else
				flyable = true
			end
		end
	else
		flyable = false
	end

	--[[
	for i, v in pairs(Mountiful_zoneFlyLevel) do -- Check if the player can fly in the current zone
		if i == zoneName then
			if Mountiful_zoneFlyLevel[i] == 70 and level >= 70 then
				flyable = true
			elseif (level >= Mountiful_zoneFlyLevel[i]) and coldweatherflying then
				flyable = true
			else
				flyable = false
			end
		end
	end
	if in_array(subZone, Mountiful_flyableSubZones) and coldweatherflying then
		flyable = true
	end
	
	--start daxdax
	if(IsFlyableArea() and (zoneName ~= "Wintergrasp" and zoneName ~= "Dalaran")) then
		flyable = true  --this should catch ANYTHING.  I dont know why jonar didnt just do this
	end
	--]]

	if mountnum ~= Mountiful_Mounts.count then -- If the number of mounts known is larger then the number stored rebuild the table
		Mountiful_CreateMountTables()
	end

	-- Pick a mount from the first array that is not empty
	if (strfind(zoneName,"Qiraj") and (#Mountiful_Mounts.Qiraj > 0)) then
		tablename = "Qiraj"
	elseif flyable and #Mountiful_Mounts.ExtremeFlying > 0 then
		tablename = "ExtremeFlying"
	elseif flyable and #Mountiful_Mounts.FastFlying > 0 then
		tablename = "FastFlying"
	elseif flyable and #Mountiful_Mounts.SlowFlying > 0 then
		tablename = "SlowFlying"
	elseif IsSwimming() and #Mountiful_Mounts.Swimming > 0 then
		tablename = "Swimming"		
	elseif #Mountiful_Mounts.FastGround > 0 then
		tablename = "FastGround"
	elseif #Mountiful_Mounts.SlowGround > 0 then
		tablename = "SlowGround"
	else
		print("No mounts available")
		return
	end
	
	Mountiful_Mount(tablename,predefined)
		
	--end daxdax
	
end
function GetRidingSkill() --retrive and return players riding skill
	for skillIndex = 1, GetNumSkillLines() do
		skillName, _, _, skillRank, _, _, _, _, _, _, _, _, _ = GetSkillLineInfo(skillIndex)
		if skillName == "Riding" then
			return skillRank
		end
	end
end

-- Goto next page of mounts/pets
function Mountiful_NextPage()

	mountifulpagenum = mountifulpagenum + 1
	Mountiful_update()
	MOprint("NEXT page.  Now at:"..mountifulpagenum)

--[[
	local paneName, pageNum = strsplit("_", this:GetName())
	local currentPage = _G[paneName.."_"..pageNum]
	local pageNum = tonumber(pageNum)
	local nextPage = _G[paneName.."_"..(pageNum+1)]
	if nextPage then --check if there is a 2nd page
		currentPage:Hide()
		nextPage:Show()
		if not _G[paneName.."_"..(pageNum+2)] then --if there is no page after the one we are going to disable its next button
			_G[paneName.."_"..(pageNum+1).."_NextPage"]:Disable()
		end
	end
	lastpane = nextPage
	]]
end

-- Goto previous page of mounts/pets
function Mountiful_PrevPage()

	mountifulpagenum = mountifulpagenum - 1
	Mountiful_update()
	--[[
	local paneName, pageNum = strsplit("_", this:GetName())
	local currentPage = _G[paneName.."_"..pageNum]
	local pageNum = tonumber(pageNum)
	if pageNum > 1 then
		local nextPage = _G[paneName.."_"..(pageNum-1)]
		currentPage:Hide()
		nextPage:Show()
	end
	lastpane = nextPage
	]]
end

function Mountiful_RebuildSelections() -- Rebuild the selections array because it gets messed up after learning new mounts

Mountiful_CreateMountTables()

--[[
	local mountnum = GetNumCompanions("MOUNT")
	local petnum = GetNumCompanions("CRITTER")
	local num, companiontype

	for k, _ in pairs(Mountiful_Selections) do
		MOprint("k = "..k)
		if Mountiful_Selections[k].ispet then num = petnum; companiontype = "CRITTER"
			num = petnum; companiontype = "CRITTER"
		else
			num = mountnum; companiontype = "MOUNT"
		end
		for i=1, num do
			local _, name, spellID, icon, _ = GetCompanionInfo(companiontype, i)
			for k2, _ in pairs(Mountiful_Selections[k]) do
				if k2 == name then
					Mountiful_Selections[k][k2]["id"] = i
				end
			end
		end
	end
	]]
	
end
function Mountiful_ResetSettings()
	Mountiful_Vars = nil
	ReloadUI()
end

function Mountiful_CreateMountTables()
	MOprint("Entering |c00ffff00 CreateMountTables")
	local mountnum = GetNumCompanions("MOUNT")
	local flyable
	local zoneName = GetRealZoneText()
	local subZone = GetSubZoneText()
	local ridingSkill = GetRidingSkill()
	local level = UnitLevel("player") -- Get players level
	local tmpnum
	local coldweatherflying, _ = IsUsableSpell("Cold Weather Flying") -- Does the player have Cold Weather Flying?
	local text, link,mountname,spellID,icon
	-- Empty the mounts tables
	if(not Mountiful_Mounts) then 
		Mountiful_Mounts = {}
	end
	for key,value in pairs(Mountiful_Defaults.Categories) do
		Mountiful_Mounts[value] = {}
	end
	Mountiful_Mounts.All = {}

	if(not MountifulTooltip) then
		CreateFrame("GameTooltip", "MountifulTooltip", nil, "GameTooltipTemplate") 
		--CreateFrame("GameTooltip", "MountifulTooltip", UIParent, "GameTooltipTemplate") -- Create tooltip for parsing  --yeah, over and over and over
		--GameTooltip_SetDefaultAnchor(MountifulTooltip, UIParent)  --bad.  this sets the tooltip as the games default tooltip!  
		MountifulTooltip:SetOwner(WorldFrame,"ANCHOR_NONE")

		--MountifulTooltip:AddFontStrings(MountifulTooltip:CreateFontString("$parentTextLeft1", nil, "GameTooltipText"),MountifulTooltip:CreateFontString("$parentTextRight1", nil, "GameTooltipText"))
		
	end
	
	-- Loops through all mounts and sorts them into tables depending on speed and if they can fly
	for i=1, mountnum do
		 _, mountname, spellID, icon, _ = GetCompanionInfo("MOUNT", i)
		 
		 Mountiful_Mounts.All[#Mountiful_Mounts.All+1] = i
		 
		 link = GetSpellLink(spellID)
		--MOprint(mountname)
		
		MountifulTooltip:SetHyperlink(link) -- Set link for tooltip
		text = _G["MountifulTooltipTextLeft"..3]:GetText() -- Get the description text from the tooltip
		
		
		
		if(text) then
			if(strfind (text, "swimmer")) then
				Mountiful_Mounts.Swimming[#Mountiful_Mounts.Swimming + 1] = i
			elseif(strfind (text, "Qiraj")) then
				Mountiful_Mounts.Qiraj[#Mountiful_Mounts.Qiraj+ 1] = i
			elseif strfind (text, "changes") and strfind (text, "location") then -- Catches mounts that change depending on location and skill
				Mountiful_Mounts.FastFlying[#Mountiful_Mounts.FastFlying+1] = i
				Mountiful_Mounts.SlowFlying[#Mountiful_Mounts.SlowFlying+1] = i
				Mountiful_Mounts.FastGround[#Mountiful_Mounts.FastGround+1] = i
				Mountiful_Mounts.SlowGround[#Mountiful_Mounts.SlowGround+1] = i
			elseif strfind(text, "changes") and not strfind(text, "Outland") then -- Catches mounts that change depending on skill
				Mountiful_Mounts.FastGround[#Mountiful_Mounts.FastGround+1] = i
				Mountiful_Mounts.SlowGround[#Mountiful_Mounts.SlowGround+1] = i
			elseif strfind(text, "Outland") then -- Catches flying mounts
				if ridingSkill >= 300 and strfind(text, "extremely") then -- Catches 310% mounts
					Mountiful_Mounts.ExtremeFlying[#Mountiful_Mounts.ExtremeFlying+1] = i
				elseif ridingSkill >= 300 and (strfind(text, "very") or strfind(text, "changes"))then -- Catches epic flyers
					Mountiful_Mounts.FastFlying[#Mountiful_Mounts.FastFlying+1] = i
				else
					Mountiful_Mounts.SlowFlying[#Mountiful_Mounts.SlowFlying+1] = i
				end
			elseif not strfind(text, "Outland") then
				if ridingSkill >= 150 and strfind(text, "very")then
					Mountiful_Mounts.FastGround[#Mountiful_Mounts.FastGround+1] = i
				else
					Mountiful_Mounts.SlowGround[#Mountiful_Mounts.SlowGround+1] = i
				end
			end
		end
	end
	
	--Mountiful_Tooltip = nil  --other tooltip mods seem to break - maybe this will fix things.
	
	Mountiful_Mounts.count = mountnum -- Store the current number of mounts
	
	mountnum = GetNumCompanions("CRITTER")
	Mountiful_Mounts.Pet = {}
	for i = 1, mountnum do
		_, mountname, spellID, icon, _ = GetCompanionInfo("CRITTER", i)
		Mountiful_Mounts.Pet[#Mountiful_Mounts.Pet+1] = i
	end
end

function Mountiful_HideAllPanels()  --just for debugging purposes  --not in use
	local pagenum,paneltext
	for i, panelname in ipairs(Mountiful_Categories) do --Loop through panels stored in SV
		panel = getglobal(panelname.."_1")  
		--print("Attempting to retrieve panel_1:"..panelname)
		pagenum = 2
		while (panel) do
			--print("Panel name:"..panel:GetName().." found.  Hiding.")
			panel:Hide()
			paneltext = getglobal(panel:GetName().."_Name")
			if(paneltext) then paneltext:Hide() end;
			panel = getglobal(panelname.."_"..pagenum)
			pagenum = pagenum+1
		end
	end
end	

function Mountiful_Refresh()  --ditto

	MOprint("|c00ffff00 REFRESH |rentered")

	local panelname,index,value,paneltext,button
	

	Mountiful_CreateMountTables()
	
	if(Mountiful_Mounts.FastGround[1]) then
	
		MOprint("first mount in fastgroundtable: "..tostring(Mountiful_Mounts.FastGround[1]))
	else
		MOprint("ERRORR!  NO MOUNT TABLE")
	end
	
	for index,value in pairs(Mountiful_Categories) do
		if(type(value) == "string") then
			--value = Mountiful_Categories[1]  --just get the first and the rest will follow  --fastground
			--MOprint("Looping through mountiful_Categories.  Index = "..tostring(index).."  value="..tostring(value))
			panelname = value
			panel = getglobal(panelname.."_1")
			MOprint(panelname.."_1   found.  name="..panel:GetName().."  entering createmoutnselectors")
			
			
			
			--mountname = mounts[1]
			 _, mountname, spellID, icon, _ = GetCompanionInfo("MOUNT", 1)
			MOprint("my first mount is "..mountname)
			
			mounticon = getglobal(panelname.."_"..mountname)
			if(mounticon) then
				MOprint("Mounticon found.")
			else
				MOprint("Mounticon |c00ff0000NOT found.")
				--mounticon = CreateFrame("Frame", panelname.."_"..mountname, panel, "MountifulIcon")
				Mountiful_CreateMountSelectors(panelname, panel)
				mounticon = getglobal(panelname.."_"..mountname)
			end
			if(mounticon) then
				button = getglobal(panelname.."_"..mountname.."_MountIcon")
				if(button) then
					MOprint("button found.")
				else
					MOprint("button |c00ff0000NOT found.")
				end
				mounttexture = getglobal(panelname.."_"..mountname.."_MountIcon_IconTexture")
				if(mounttexture) then
					MOprint("texture found.")
				else
					MOprint("texture |c00ff0000NOT found.")
				end
				checkbox = getglobal(panelname.."_"..mountname.."_CheckButton")
				if(checkbox) then
					MOprint("checkbox found.")
				else
					MOprint("checkboxn |c00ff0000NOT found.")
				end
				mounttexture:SetTexture(icon)
				--checkbox:SetID(value)
				
				--mounticon:SetPoint("Topleft")
				
				mounticon:Show()
				button:SetNormalTexture("Interface\Buttons\UI-Quickslot2")
				
				
			end
			
			paneltext = getglobal(panel:GetName().."_Name")
			button = getglobal(panelname.."_Button")
			--getglobal(panelname.."_1".."_PrevPage"):Disable()
			if(Mountiful_Mounts[panelname]) then
				button:SetText(panelname.." ("..#Mountiful_Mounts[panelname]..")")
			else
				button:SetText(panelname)
			end
			paneltext:SetText(panelname)
		end
	end
end

function mountifulgetpanelnum(panelname)
	for i =1,#Mountiful_Categories do
		if(Mountiful_Categories[i] == panelname) then
			return i
		end
	end
	return nil
end